-- RMCm_cmd.lua
-- Resurgence Map Control M Routines

--====================================================================
-- this script controls access to the Mundilfoeri maps of Resurgence
-- implementing the clickable buttons which make various maps visible
--====================================================================
-- ----------------------------
-- define tables of page visibility states
-- ----------------------------

-- table of all affected objects
-- this is used to hide them all before drawing the currently visible ones

mt_all = {
"MundilfoeriMap",
"MuspelionButton",
"JotanisButton",
"AsgariaButton",
"LyosaButton",
"SormorButton",
"NivelionButton",
"MedgariaButton",

"MundilfoeriOrreryMap",
"ShowMOrreryButton",
"HideMOrreryButton",

"MuspelionMap",
"JotanisMap",
"AsgariaMap",
"LyosaMap",
"SormorMap",
"NivelionMap",
"MedgariaMap",

"MuspelionGlobeLbl",
"JotanisGlobeLbl",
"AsgariaGlobeLbl",
"LyosaGlobeLbl",
"SormorGlobeLbl",
"NivelionGlobeLbl",
"MedgariaGlobeLbl",

"MuspelionGlobeNoLbl",
"JotanisGlobeNoLbl",
"AsgariaGlobeNoLbl",
"LyosaGlobeNoLbl",
"SormorGlobeNoLbl",
"NivelionGlobeNoLbl",
"MedgariaGlobeNoLbl",

"MuspelionGlobeNocl",
"JotanisGlobeNocl",
"AsgariaGlobeNocl",
"LyosaGlobeNocl",
"SormorGlobeNocl",
"NivelionGlobeNocl",
"MedgariaGlobeNocl",

"MButton",
"ShowGlobeM",

"DropDownButtonM",
"DropUpButtonM",
"DropDownM",
"SoftwareFailure",
}

-- the orrery's objects:
-- renamed+repositioned+resized star, planets and moons

mt_orrery = {
"Alvaldi_",
"Alvisso_",
"Asgaria_",
"Fenrir_",
"Hati_",
"Jotanis_",
"Lyosa_",
"Managarm_",
"Medgaria_",
"Mundilfoeri_",
"Muspelion_",
"Neper_",
"Niana_",
"Nivelion_",
"Sinotra_",
"Skeldia_",
"Skirnir_",
"Skollia_",
"Sleipnir_",
"Sormor_",
"Urda_",
"Var_",
"Verdandi_",
"Vergre_",
}

mt_bkg_maps = {
"MuspelionMap",
"JotanisMap",
"AsgariaMap",
"LyosaMap",
"SormorMap",
"NivelionMap",
"MedgariaMap",
}
mt_globes_nolbl = {
"MuspelionGlobeNoLbl",
"JotanisGlobeNoLbl",
"AsgariaGlobeNoLbl",
"LyosaGlobeNoLbl",
"SormorGlobeNoLbl",
"NivelionGlobeNoLbl",
"MedgariaGlobeNoLbl",
}
mt_globes_lbl = {
"MuspelionGlobeLbl",
"JotanisGlobeLbl",
"AsgariaGlobeLbl",
"LyosaGlobeLbl",
"SormorGlobeLbl",
"NivelionGlobeLbl",
"MedgariaGlobeLbl",
}

mt_globes_nocl = {
"MuspelionGlobeNocl",
"JotanisGlobeNocl",
"AsgariaGlobeNocl",
"LyosaGlobeNocl",
"SormorGlobeNocl",
"NivelionGlobeNocl",
"MedgariaGlobeNocl",
}

-- all Rv1 maps but Mundilfoeri 
mt_Rv1_maps = {
"GalaxyMap_lbl",
"GalaxyMap_nolbl",
"HadesMap",
"HeliosMap",
"HephaestiMap",
"HyperionMap",
"HyperionMap_nosys",
"LunaMap",
"MercariMap",
-- "MundilfoeriMap",
"NeogeaMap",
"NeosolMap",
"ScyllaMap",
"SeshaMap",
"SolaMap",
"SuryaNayirMap",
"ThartarMap",
}

-- ----------
-- Potential buttons on drop-down menu 
-- ----------
mt_ddm = {
"DDb1M",
"DDb2M",
"DDb3M",
"DDb4M",
"DDb5M",
"DDb6M",
"DDb7M",
"DDb8M",
"DDb9M",
"DDb10M",
"DDb11M",
"DDb12M",
"DDb13M",
"DDb14M",
"DDb15M",
"DDb16M",
"DDb17M",
"DDb18M",
"DDb19M",
"DDb20M",
"DDb21M",
"DDb22M",
"DDb23M",
"DDb24M",
"DDb25M",
"DDb26M",
}
-- ---------
-- System map
-- ---------

mt_Mundilfoeri = {
"MundilfoeriMap",
"ShowMOrreryButton",
"MuspelionButton",
"JotanisButton",
"AsgariaButton",
"LyosaButton",
"SormorButton",
"NivelionButton",
"MedgariaButton",
}

mtb_Mundilfoeri = {
"ShowMOrreryButton",
"MuspelionButton",
"JotanisButton",
"AsgariaButton",
"LyosaButton",
"SormorButton",
"NivelionButton",
"MedgariaButton",
}

-- Rv1 buttons for Mundilforei map
mtb_mund = {
"NeosolButton",
"Button1",
"Button2",
"Button3",
}

-- ---------
-- Planetary maps
-- ---------

mt_SoftwareFailure = {
"SoftwareFailure",
}

mt_Muspelion = {
"MuspelionMap",
"MButton",
"ShowGlobeM",
}

mt_Jotanis = {
"JotanisMap",
"MButton",
"ShowGlobeM",
}

mt_Asgaria = {
"AsgariaMap",
"MButton",
"ShowGlobeM",
}

mt_Lyosa = {
"LyosaMap",
"MButton",
"ShowGlobeM",
}

mt_Sormor = {
"SormorMap",
"MButton",
"ShowGlobeM",
}

mt_Nivelion = {
"NivelionMap",
"MButton",
"ShowGlobeM",
}

mt_Medgaria = {
"MedgariaMap",
"MButton",
"ShowGlobeM",
}

-- ----------------------------
-- functions to hide and show the maps
-- ----------------------------

-- ---------------
mc_show = function (name)
   celestia:find(name):setvisible(true)
end

-- ---------------
mc_hide = function (name)
   celestia:find(name):setvisible(false)
end
-- ---------------

mc_show_tbl = function (map_table)
  for j,r in ipairs(map_table) do
    mc_show(map_table[j])
  end -- for j,r loop
end

-- ---------------
mc_hide_tbl = function (map_table)
  for j,r in ipairs(map_table) do
   celestia:find(map_table[j]):setvisible(false)
  end -- for j,r loop
end

-- ---------------

-- hide all maps and buttons
mc_show_none = function ()
  if (m_coop) then show_none()  end
  mc_hide_tbl(mt_all)

  local obj=celestia:find("ResurgenceCore")
  celestia:select(obj)
  mc_hide_tbl(mt_orrery)
  mc_hide_tbl(mt_ddm)
end

-- show a map and its buttons
mc_show_map = function (map_table)
-- turn all stuff off
  mc_show_none()
-- turn this stuff on
  if (m_coop) then
    show("DropDownButton")
  else
    mc_show("DropDownButtonM")
  end
  mc_show_tbl(map_table)
end

-- show map of Mundilfoeri System
-- if cooperating, show other Addon's hires map
-- else show local lores map

mcm_show_map = function ()
-- turn all stuff off
  mc_show_none()
-- turn this stuff on
  if (m_coop) then
-- show Rv1 map
   show_map(rmt_mund)
-- and M buttons
   mc_show_tbl(mtb_Mundilfoeri)
  else
    mc_show_map(mt_Mundilfoeri)
  end
end

--====================================================================
-- command routines
--====================================================================

-- show various globes in front of map of planet
mc_toggle_globe = function ()

-- find name of currently visible background map
  for j,r in ipairs(mt_bkg_maps) do
    local obj = celestia:find(mt_bkg_maps[j])
    if ( obj:visible() )
    then

-- set visibility of corresponding globes
     if ( celestia:find(mt_globes_lbl[j]):visible() )
     then
          celestia:find(mt_globes_lbl[j]):setvisible(false)
          celestia:find(mt_globes_nocl[j]):setvisible(true)

     elseif ( celestia:find(mt_globes_nocl[j]):visible())
     then
          celestia:find(mt_globes_nocl[j]):setvisible(false)
          celestia:find(mt_globes_nolbl[j]):setvisible(true)

     elseif ( celestia:find(mt_globes_nolbl[j]):visible())
     then
          celestia:find(mt_globes_nolbl[j]):setvisible(false)
     else
          celestia:find(mt_globes_lbl[j]):setvisible(true)
     end
     return
   end
  end
end

mc_show_orrery = function ()
     if(m_coop)
     then
	mc_show_map(mtb_mund)
     else
        mc_show_none()
     end

     mc_show("HideMOrreryButton")
     mc_show("MundilfoeriOrreryMap")

     celestia:setrenderflags{ orbits = true }
     celestia:setorbitflags{ Spacecraft = true }
     celestia:setlabelflags{ spacecraft = true }

     local obj=celestia:find("ResurgenceCore")
     celestia:select(obj)
     mc_show_tbl(mt_orrery)
end

mc_hide_orrery = function ()
  if (m_coop) then
   mc_show_none()
-- show Rv1 map and buttons
   mc_show_map(mtb_mund)
   show_map(rmt_mund)
-- and M buttons
   mc_show_tbl(mtb_Mundilfoeri)
  else
    mc_show_map(mt_Mundilfoeri)
  end
end

-- dropdown menu control
mc_dd = function()
	   mc_show ("DropDownM")
	   mc_show_tbl (mt_ddm)
	   mc_show ("DropUpButtonM")
	   mc_hide ("DropDownButtonM")
end
mc_du = function()
	   mc_hide ("DropDownM")
	   mc_hide_tbl (mt_ddm)
	   mc_hide ("DropUpButtonM")
	   mc_show ("DropDownButtonM")
end


-- leave maps and go to Mundilfoeri system
mc_gotom = function()
  celestia:setorbitflags{ Planet = true }
  celestia:setorbitflags{ Moon = true }
  celestia:setlabelflags{ planets = true}
  celestia:setlabelflags{ moons = true}
  local mars = celestia:find("Mundilfoeri")
  celestia:select(mars)
  local frame = celestia:newframe("ecliptic", mars)
  local obs = celestia:getobserver()
  obs:setframe(frame)
  local marsradius = mars:radius()
  local marsdistance = 7.0e3 * marsradius
  local upaxis = celestia:newvector(0,1,0)
  obs:gotodistance(mars, marsdistance, 5.0, upaxis)

end


-- ===================================
-- detect if this Addon is standalone
-- or is accompanied by the original Resurgence Addon
-- ===================================

  m_1st = true
  m_2nd = nil
  m_coop = nil

mc_init = function ()
-- does stuff only the 1st and 2nd times it's called
  if (m_1st)
    then
-- can't guarantee that Resurgence has been loaded yet
	m_1st = nil
	m_2nd = true
	return
  elseif (m_2nd)
    then
-- Resurgence v1 must have been loaded by now
	m_1st = nil
	m_2nd = nil

   local obj, ctype
   obj=celestia:find("ResurgenceCore/GalaxyMap_nolbl")
   ctype = obj:type()
       if (ctype == "spacecraft")
       then
-- hide initial map and buttons
	   m_coop = true
	   mc_hide_tbl(mt_all)
	   mc_hide_map(mt_Mundilfoeri)
  	   return
	else
-- show initial map and buttons
	   mc_show_map(mt_Mundilfoeri)
       end
  end
end

-- test for Rv1 maps:
-- hide all M stuff if one is visible

mc_test_for_Rv1 = function()
  for j,r in ipairs(mt_Rv1_maps) do
    if ( celestia:find(mt_Rv1_maps[j]):visible() )
    then
      mc_hide_tbl(mt_all)
      mc_hide_tbl(mt_orrery)
      return
    end
  end
end

-- add buttons to map
mc_test_for_Mundilfoeri = function()
    local map = "MundilfoeriMap"
    local obj = celestia:find(map)
    if ( obj:visible() )
    then
      mc_show_tbl(mtb_Mundilfoeri)
    else
      mc_hide_tbl(mtb_Mundilfoeri)
    end
end

-- add secondary menu
mc_test_for_dropdown_menu = function()
    local map = "DropDown"
    local obj = celestia:find(map)
    if ( obj:visible() )
    then
      mc_show ("DropDownM")
      mc_show_tbl (mt_ddm)
    else
      mc_hide ("DropDownM")
      mc_hide_tbl (mt_ddm)
    end
end

--====================================================================
-- command processor table and routines:
-- the name of the selected object is interpreted as a command
--====================================================================

-- m_selP = previous selection
-- to be restored immediately after recognizing a command
-- assume initial selection (if any) when Celestia starts isn't a command

-- must be initialized
-- but can't use getselection during startup of Celestia
-- which is when this code is initially executed
-- because nothing has been selected yet

m_selP = nil

-- ======================================= 
-- table of commands:
-- command text (i.e.name of selected object) = { command function, arg_of_fn },

mt_cmds = {
 RC_M = {mc_show_map,mt_Mundilfoeri},
 MuspelionButton = {mc_show_map,mt_Muspelion},
 JotanisButton = {mc_show_map,mt_Jotanis},
 AsgariaButton = {mc_show_map,mt_Asgaria},
 LyosaButton = {mc_show_map,mt_Lyosa},
 SormorButton = {mc_show_map,mt_Sormor},
 NivelionButton = {mc_show_map,mt_Nivelion},
 MedgariaButton = {mc_show_map,mt_Medgaria},
 MButton = {mc_show_map,mt_Mundilfoeri},
 ShowGlobeM = {mc_toggle_globe, nil},
 ShowMOrreryButton = {mc_show_orrery, nil},
 HideMOrreryButton = {mc_hide_orrery, nil},
 DropDownButtonM = {mc_dd, nil},
 DropUpButtonM = {mc_du, nil},
--
 DDb1M = {mc_du,nil},
 DDb2M = {mcm_show_map,nil},
 DDb3M = {mc_show_map,mt_Muspelion},
 DDb4M = {mc_show_map,mt_Jotanis},
 DDb5M = {mc_show_map,mt_Asgaria},
 DDb6M = {mc_show_map,mt_Lyosa},
 DDb7M = {mc_show_map,mt_Sormor},
 DDb8M = {mc_show_map,mt_Nivelion},
-- DDb9M = {mc_show_map,mt_SoftwareFailure},
 DDb10M = {mc_show_map,mt_Medgaria},
-- DDb11M = {mc_show_map,
 DDb12M = {mc_gotom,nil}, 
-- DropDownM = {mc_show_map,mt_SoftwareFailure},
 }


-- ======================================= 
-- action function

mc_rm_cmd = function (this_date)


-- co-operative activities:
-- monitor status of Resurgence maps
-- and show Mundilfoeri stuff depending on what's visible

   if (m_coop)
   then
     mc_test_for_Rv1()
     mc_test_for_Mundilfoeri()
     mc_test_for_dropdown_menu()
   end

-- to implement commands only for the Mundilfoeri map and its children
-- this code uses locals, mc_ routines and mt_ tables

  local sel = celestia:getselection()

  if (sel == m_selP) then return 0 end
  
  local sname = sel:name()
  
-- get the two-element table (if any) matching the name of the selection
  local todo = mt_cmds[sname]
  
    if todo then 
     -- restore previous selection before executing this one
        if (m_selP ~= nil) then celestia:select(m_selP) end
	
	-- call the function [table element 1] associated with this command,
	-- passing it a single argument [table element 2]
	todo[1](todo[2])
	return 1
    end

-- This selection is not recognized as a command,
-- so save it for reversion after next command

	m_selP = sel
	return 0
end

